diff --git a/glusterfsd/src/glusterfsd.c b/glusterfsd/src/glusterfsd.c
index f36ce2b0ffc..c4fa2e954c1 100644
--- a/glusterfsd/src/glusterfsd.c
+++ b/glusterfsd/src/glusterfsd.c
@@ -2079,8 +2079,8 @@ parse_cmdline(int argc, char *argv[], glusterfs_ctx_t *ctx)
         if (((ret == 0) &&
              (S_ISREG(stbuf.st_mode) || S_ISLNK(stbuf.st_mode))) ||
             (ret == -1)) {
-            /* Have separate logfile per run */
-            gf_time_fmt(timestr, sizeof timestr, time(NULL), gf_timefmt_FT);
+            /* Have separate logfile per run. */
+            gf_time_fmt(timestr, sizeof timestr, gf_time(), gf_timefmt_FT);
             sprintf(tmp_logfile, "%s.%s.%d", cmd_args->log_file, timestr,
                     getpid());
 
diff --git a/libglusterfs/src/common-utils.c b/libglusterfs/src/common-utils.c
index c37c45449f2..bff4c3d633b 100644
--- a/libglusterfs/src/common-utils.c
+++ b/libglusterfs/src/common-utils.c
@@ -646,7 +646,7 @@ gf_rev_dns_lookup_cached(const char *ip, struct dnscache *dnscache)
     if (entrydata) {
         dnsentry = (struct dnscache_entry *)entrydata->data;
         /* First check the TTL & timestamp */
-        if (time(NULL) - dnsentry->timestamp > dnscache->ttl) {
+        if (gf_time() - dnsentry->timestamp > dnscache->ttl) {
             gf_dnscache_entry_deinit(dnsentry);
             entrydata->data = NULL; /* Mark this as 'null' so
                                      * dict_del () doesn't try free
@@ -683,7 +683,7 @@ gf_rev_dns_lookup_cached(const char *ip, struct dnscache *dnscache)
         if (entry) {
             entry->fqdn = fqdn;
             entry->ip = gf_strdup(ip);
-            entry->timestamp = time(NULL);
+            entry->timestamp = gf_time();
             entrydata = bin_to_data(entry, sizeof(*entry));
             dict_set(cache, (char *)ip, entrydata);
         }
@@ -935,7 +935,7 @@ gf_print_trace(int32_t signum, glusterfs_ctx_t *ctx)
     {
         /* Dump the timestamp of the crash too, so the previous logs
            can be related */
-        gf_time_fmt(timestr, sizeof timestr, time(NULL), gf_timefmt_FT);
+        gf_time_fmt(timestr, sizeof timestr, gf_time(), gf_timefmt_FT);
         gf_msg_plain_nomem(GF_LOG_ALERT, "time of crash: ");
         gf_msg_plain_nomem(GF_LOG_ALERT, timestr);
     }
diff --git a/libglusterfs/src/events.c b/libglusterfs/src/events.c
index 6d1e3836477..908a318a8a1 100644
--- a/libglusterfs/src/events.c
+++ b/libglusterfs/src/events.c
@@ -93,7 +93,7 @@ _gf_event(eventtypes_t event, const char *fmt, ...)
         goto out;
     }
 
-    ret = gf_asprintf(&eventstr, "%u %d %s", (unsigned)time(NULL), event, msg);
+    ret = gf_asprintf(&eventstr, "%u %d %s", (unsigned)gf_time(), event, msg);
     GF_FREE(msg);
     if (ret <= 0) {
         ret = EVENT_ERROR_MSG_FORMAT;
diff --git a/libglusterfs/src/gidcache.c b/libglusterfs/src/gidcache.c
index 40fcffbb35e..64a93802f76 100644
--- a/libglusterfs/src/gidcache.c
+++ b/libglusterfs/src/gidcache.c
@@ -10,6 +10,7 @@
 
 #include "glusterfs/gidcache.h"
 #include "glusterfs/mem-pool.h"
+#include "glusterfs/common-utils.h"
 
 /*
  * We treat this as a very simple set-associative LRU cache, with entries aged
@@ -64,7 +65,7 @@ gid_cache_lookup(gid_cache_t *cache, uint64_t id, uint64_t uid, uint64_t gid)
     time_t now;
     const gid_list_t *agl;
 
-    now = time(NULL);
+    now = gf_time();
     LOCK(&cache->gc_lock);
     bucket = id % cache->gc_nbuckets;
     agl = BUCKET_START(cache->gc_cache, bucket);
@@ -132,7 +133,7 @@ gid_cache_add(gid_cache_t *cache, gid_list_t *gl)
     if (!cache->gc_max_age)
         return 0;
 
-    now = time(NULL);
+    now = gf_time();
     LOCK(&cache->gc_lock);
 
     /*
diff --git a/libglusterfs/src/glusterfs/common-utils.h b/libglusterfs/src/glusterfs/common-utils.h
index f05bda1f537..d605beae461 100644
--- a/libglusterfs/src/glusterfs/common-utils.h
+++ b/libglusterfs/src/glusterfs/common-utils.h
@@ -1213,4 +1213,10 @@ gf_syncfs(int fd);
 int
 gf_nanosleep(uint64_t nsec);
 
+static inline time_t
+gf_time(void)
+{
+    return time(NULL);
+}
+
 #endif /* _COMMON_UTILS_H */
diff --git a/libglusterfs/src/statedump.c b/libglusterfs/src/statedump.c
index 655317f3ef1..68e01104023 100644
--- a/libglusterfs/src/statedump.c
+++ b/libglusterfs/src/statedump.c
@@ -843,7 +843,7 @@ gf_proc_dump_info(int signum, glusterfs_ctx_t *ctx)
              ? dump_options.dump_path
              : ((ctx->statedump_path != NULL) ? ctx->statedump_path
                                               : DEFAULT_VAR_RUN_DIRECTORY)),
-        brick_name, getpid(), (uint64_t)time(NULL));
+        brick_name, getpid(), (uint64_t)gf_time());
     if ((ret < 0) || (ret >= sizeof(path))) {
         goto out;
     }
diff --git a/libglusterfs/src/syncop.c b/libglusterfs/src/syncop.c
index 95bea675379..df20cec559f 100644
--- a/libglusterfs/src/syncop.c
+++ b/libglusterfs/src/syncop.c
@@ -593,7 +593,7 @@ syncenv_task(struct syncproc *proc)
 
             env->procs_idle++;
 
-            sleep_till.tv_sec = time(NULL) + SYNCPROC_IDLE_TIME;
+            sleep_till.tv_sec = gf_time() + SYNCPROC_IDLE_TIME;
             ret = pthread_cond_timedwait(&env->cond, &env->mutex, &sleep_till);
 
             env->procs_idle--;
diff --git a/xlators/cluster/afr/src/afr-self-heald.c b/xlators/cluster/afr/src/afr-self-heald.c
index 2219a53b277..bf3c771f085 100644
--- a/xlators/cluster/afr/src/afr-self-heald.c
+++ b/xlators/cluster/afr/src/afr-self-heald.c
@@ -94,7 +94,7 @@ __afr_shd_healer_wait(struct subvol_healer *healer)
     priv = healer->this->private;
 
 disabled_loop:
-    wait_till.tv_sec = time(NULL) + priv->shd.timeout;
+    wait_till.tv_sec = gf_time() + priv->shd.timeout;
 
     while (!healer->rerun) {
         ret = pthread_cond_timedwait(&healer->cond, &healer->mutex, &wait_till);
diff --git a/xlators/cluster/ec/src/ec-heald.c b/xlators/cluster/ec/src/ec-heald.c
index 63fe5d34e38..679cfe1c839 100644
--- a/xlators/cluster/ec/src/ec-heald.c
+++ b/xlators/cluster/ec/src/ec-heald.c
@@ -62,7 +62,7 @@ __ec_shd_healer_wait(struct subvol_healer *healer)
     ec = healer->this->private;
 
 disabled_loop:
-    wait_till.tv_sec = time(NULL) + ec->shd.timeout;
+    wait_till.tv_sec = gf_time() + ec->shd.timeout;
 
     while (!healer->rerun) {
         ret = pthread_cond_timedwait(&healer->cond, &healer->mutex, &wait_till);
diff --git a/xlators/debug/error-gen/src/error-gen.c b/xlators/debug/error-gen/src/error-gen.c
index 0158e8d8546..d45655ef4c3 100644
--- a/xlators/debug/error-gen/src/error-gen.c
+++ b/xlators/debug/error-gen/src/error-gen.c
@@ -1507,8 +1507,8 @@ init(xlator_t *this)
 
     this->private = pvt;
 
-    /* Give some seed value here */
-    srand(time(NULL));
+    /* Give some seed value here. */
+    srand(gf_time());
 
     ret = 0;
 out:
diff --git a/xlators/features/changelog/src/changelog-helpers.c b/xlators/features/changelog/src/changelog-helpers.c
index 71fe1f032a0..ba9d4e03e20 100644
--- a/xlators/features/changelog/src/changelog-helpers.c
+++ b/xlators/features/changelog/src/changelog-helpers.c
@@ -1274,7 +1274,7 @@ changelog_rollover(void *data)
     while (1) {
         (void)pthread_testcancel();
 
-        tv.tv_sec = time(NULL) + priv->rollover_time;
+        tv.tv_sec = gf_time() + priv->rollover_time;
         tv.tv_nsec = 0;
         ret = 0; /* Reset ret to zero */
 
diff --git a/xlators/features/cloudsync/src/cloudsync-plugins/src/cloudsyncs3/src/libcloudsyncs3.c b/xlators/features/cloudsync/src/cloudsync-plugins/src/cloudsyncs3/src/libcloudsyncs3.c
index 7680260988b..23c3599825a 100644
--- a/xlators/features/cloudsync/src/cloudsync-plugins/src/cloudsyncs3/src/libcloudsyncs3.c
+++ b/xlators/features/cloudsync/src/cloudsync-plugins/src/cloudsyncs3/src/libcloudsyncs3.c
@@ -237,7 +237,7 @@ aws_form_request(char *resource, char **date, char *reqtype, char *bucketid,
     int date_len = -1;
     int res_len = -1;
 
-    ctime = time(NULL);
+    ctime = gf_time();
     gtime = gmtime(&ctime);
 
     date_len = strftime(httpdate, sizeof(httpdate),
diff --git a/xlators/features/leases/src/leases-internal.c b/xlators/features/leases/src/leases-internal.c
index 67fdd53cee2..56dee244281 100644
--- a/xlators/features/leases/src/leases-internal.c
+++ b/xlators/features/leases/src/leases-internal.c
@@ -897,7 +897,7 @@ __recall_lease(xlator_t *this, lease_inode_ctx_t *lease_ctx)
     }
 
     priv = this->private;
-    recall_time = time(NULL);
+    recall_time = gf_time();
     list_for_each_entry_safe(lease_entry, tmp, &lease_ctx->lease_id_list,
                              lease_id_list)
     {
@@ -1367,7 +1367,7 @@ expired_recall_cleanup(void *data)
     gf_msg_debug(this->name, 0, "Started the expired_recall_cleanup thread");
 
     while (1) {
-        time_now = time(NULL);
+        time_now = gf_time();
         pthread_mutex_lock(&priv->mutex);
         {
             if (priv->fini) {
diff --git a/xlators/features/read-only/src/worm-helper.c b/xlators/features/read-only/src/worm-helper.c
index 25fbd4aa748..df45f2a940b 100644
--- a/xlators/features/read-only/src/worm-helper.c
+++ b/xlators/features/read-only/src/worm-helper.c
@@ -41,7 +41,7 @@ worm_init_state(xlator_t *this, gf_boolean_t fop_with_fd, void *file_ptr)
     GF_VALIDATE_OR_GOTO("worm", this, out);
     GF_VALIDATE_OR_GOTO(this->name, file_ptr, out);
 
-    start_time = time(NULL);
+    start_time = gf_time();
     dict = dict_new();
     if (!dict) {
         gf_log(this->name, GF_LOG_ERROR, "Error creating the dict");
@@ -94,7 +94,7 @@ worm_set_state(xlator_t *this, gf_boolean_t fop_with_fd, void *file_ptr,
     if (ret)
         goto out;
     stbuf->ia_mtime = stpre.ia_mtime;
-    stbuf->ia_atime = time(NULL) + retention_state->ret_period;
+    stbuf->ia_atime = gf_time() + retention_state->ret_period;
 
     if (fop_with_fd)
         ret = syncop_fsetattr(this, (fd_t *)file_ptr, stbuf, GF_SET_ATTR_ATIME,
@@ -286,6 +286,7 @@ gf_worm_state_transition(xlator_t *this, gf_boolean_t fop_with_fd,
 {
     int op_errno = EROFS;
     int ret = -1;
+    time_t now = 0;
     uint64_t com_period = 0;
     uint64_t start_time = 0;
     dict_t *dict = NULL;
@@ -337,8 +338,10 @@ gf_worm_state_transition(xlator_t *this, gf_boolean_t fop_with_fd,
         goto out;
     }
 
-    if (ret == -1 && (time(NULL) - start_time) >= com_period) {
-        if ((time(NULL) - stbuf.ia_mtime) >= com_period) {
+    now = gf_time();
+
+    if (ret == -1 && (now - start_time) >= com_period) {
+        if ((now - stbuf.ia_mtime) >= com_period) {
             ret = worm_set_state(this, fop_with_fd, file_ptr, &reten_state,
                                  &stbuf);
             if (ret) {
@@ -352,10 +355,10 @@ gf_worm_state_transition(xlator_t *this, gf_boolean_t fop_with_fd,
             op_errno = 0;
             goto out;
         }
-    } else if (ret == -1 && (time(NULL) - start_time) < com_period) {
+    } else if (ret == -1 && (now - start_time) < com_period) {
         op_errno = 0;
         goto out;
-    } else if (reten_state.retain && ((time(NULL) >= stbuf.ia_atime))) {
+    } else if (reten_state.retain && ((now >= stbuf.ia_atime))) {
         gf_worm_state_lookup(this, fop_with_fd, file_ptr, &reten_state, &stbuf);
     }
     if (reten_state.worm && !reten_state.retain && priv->worm_files_deletable &&
diff --git a/xlators/features/trash/src/trash.c b/xlators/features/trash/src/trash.c
index a28aa1e09e0..7d09cba3e9c 100644
--- a/xlators/features/trash/src/trash.c
+++ b/xlators/features/trash/src/trash.c
@@ -216,7 +216,7 @@ append_time_stamp(char *name, size_t name_size)
         0,
     };
 
-    gf_time_fmt(timestr, sizeof(timestr), time(NULL), gf_timefmt_F_HMS);
+    gf_time_fmt(timestr, sizeof(timestr), gf_time(), gf_timefmt_F_HMS);
 
     /* removing white spaces in timestamp */
     for (i = 0; i < strlen(timestr); i++) {
diff --git a/xlators/features/upcall/src/upcall-internal.c b/xlators/features/upcall/src/upcall-internal.c
index 978825f6b56..c641bd6f432 100644
--- a/xlators/features/upcall/src/upcall-internal.c
+++ b/xlators/features/upcall/src/upcall-internal.c
@@ -316,7 +316,7 @@ upcall_reaper_thread(void *data)
     priv = this->private;
     GF_ASSERT(priv);
 
-    time_now = time(NULL);
+    time_now = gf_time();
     while (!priv->fini) {
         list_for_each_entry_safe(inode_ctx, tmp, &priv->inode_ctx_list,
                                  inode_ctx_list)
@@ -344,7 +344,7 @@ upcall_reaper_thread(void *data)
         /* don't do a very busy loop */
         timeout = get_cache_invalidation_timeout(this);
         sleep(timeout / 2);
-        time_now = time(NULL);
+        time_now = gf_time();
     }
 
     return NULL;
@@ -533,7 +533,7 @@ upcall_cache_invalidate(call_frame_t *frame, xlator_t *this, client_t *client,
         goto out;
     }
 
-    time_now = time(NULL);
+    time_now = gf_time();
     pthread_mutex_lock(&up_inode_ctx->client_list_lock);
     {
         list_for_each_entry_safe(up_client_entry, tmp,
@@ -670,13 +670,13 @@ upcall_cache_forget(xlator_t *this, inode_t *inode,
         return;
     }
 
-    time_now = time(NULL);
+    time_now = gf_time();
     pthread_mutex_lock(&up_inode_ctx->client_list_lock);
     {
         list_for_each_entry_safe(up_client_entry, tmp,
                                  &up_inode_ctx->client_list, client_list)
         {
-            /* Set the access time to time(NULL)
+            /* Set the access time to gf_time()
              * to send notify */
             up_client_entry->access_time = time_now;
 
diff --git a/xlators/mgmt/glusterd/src/glusterd-handler.c b/xlators/mgmt/glusterd/src/glusterd-handler.c
index 7d488ffd87a..1b21c40596d 100644
--- a/xlators/mgmt/glusterd/src/glusterd-handler.c
+++ b/xlators/mgmt/glusterd/src/glusterd-handler.c
@@ -5593,7 +5593,7 @@ glusterd_get_state(rpcsvc_request_t *req, dict_t *dict)
 
     ret = dict_get_strn(dict, "filename", SLEN("filename"), &tmp_str);
     if (ret) {
-        now = time(NULL);
+        now = gf_time();
         strftime(timestamp, sizeof(timestamp), "%Y%m%d_%H%M%S",
                  localtime(&now));
         gf_asprintf(&filename, "%s_%s", "glusterd_state", timestamp);
diff --git a/xlators/mgmt/glusterd/src/glusterd-log-ops.c b/xlators/mgmt/glusterd/src/glusterd-log-ops.c
index a800d9543cf..34abf35cb00 100644
--- a/xlators/mgmt/glusterd/src/glusterd-log-ops.c
+++ b/xlators/mgmt/glusterd/src/glusterd-log-ops.c
@@ -76,7 +76,7 @@ __glusterd_handle_log_rotate(rpcsvc_request_t *req)
            "for volume %s",
            volname);
 
-    ret = dict_set_uint64(dict, "rotate-key", (uint64_t)time(NULL));
+    ret = dict_set_uint64(dict, "rotate-key", (uint64_t)gf_time());
     if (ret)
         goto out;
 
diff --git a/xlators/nfs/server/src/auth-cache.c b/xlators/nfs/server/src/auth-cache.c
index 64768646074..ffbf5b6cad6 100644
--- a/xlators/nfs/server/src/auth-cache.c
+++ b/xlators/nfs/server/src/auth-cache.c
@@ -189,7 +189,7 @@ auth_cache_add(struct auth_cache *cache, char *hashkey,
 static int
 _auth_cache_expired(struct auth_cache *cache, struct auth_cache_entry *entry)
 {
-    return ((time(NULL) - entry->timestamp) > cache->ttl_sec);
+    return ((gf_time() - entry->timestamp) > cache->ttl_sec);
 }
 
 /**
@@ -474,7 +474,7 @@ cache_nfs_fh(struct auth_cache *cache, struct nfs3_fh *fh,
         goto out;
     }
 
-    entry->timestamp = time(NULL);
+    entry->timestamp = gf_time();
     /* Update entry->item if it is pointing to a different export_item */
     if (entry->item && entry->item != export_item) {
         GF_REF_PUT(entry->item);
diff --git a/xlators/nfs/server/src/nfs3-helpers.c b/xlators/nfs/server/src/nfs3-helpers.c
index 8a58977b53c..897fb42b071 100644
--- a/xlators/nfs/server/src/nfs3-helpers.c
+++ b/xlators/nfs/server/src/nfs3-helpers.c
@@ -1072,7 +1072,7 @@ nfs3_sattr3_to_setattr_valid(sattr3 *sattr, struct iatt *buf, mode_t *omode)
     if (sattr->atime.set_it == SET_TO_SERVER_TIME) {
         valid |= GF_SET_ATTR_ATIME;
         if (buf)
-            buf->ia_atime = time(NULL);
+            buf->ia_atime = gf_time();
     }
 
     if (sattr->mtime.set_it == SET_TO_CLIENT_TIME) {
@@ -1084,7 +1084,7 @@ nfs3_sattr3_to_setattr_valid(sattr3 *sattr, struct iatt *buf, mode_t *omode)
     if (sattr->mtime.set_it == SET_TO_SERVER_TIME) {
         valid |= GF_SET_ATTR_MTIME;
         if (buf)
-            buf->ia_mtime = time(NULL);
+            buf->ia_mtime = gf_time();
     }
 
     return valid;
diff --git a/xlators/nfs/server/src/nfs3.c b/xlators/nfs/server/src/nfs3.c
index 7cfd75f9ed1..f9042bc3b3f 100644
--- a/xlators/nfs/server/src/nfs3.c
+++ b/xlators/nfs/server/src/nfs3.c
@@ -5651,7 +5651,7 @@ nfs3_init_state(xlator_t *nfsx)
         goto free_localpool;
     }
 
-    nfs3->serverstart = (uint64_t)time(NULL);
+    nfs3->serverstart = (uint64_t)gf_time();
     INIT_LIST_HEAD(&nfs3->fdlru);
     LOCK_INIT(&nfs3->fdlrulock);
     nfs3->fdcount = 0;
diff --git a/xlators/storage/posix/src/posix-helpers.c b/xlators/storage/posix/src/posix-helpers.c
index bb4a5309f45..850d6177de6 100644
--- a/xlators/storage/posix/src/posix-helpers.c
+++ b/xlators/storage/posix/src/posix-helpers.c
@@ -1950,7 +1950,7 @@ posix_fs_health_check(xlator_t *this, char *file_path)
         goto out;
     }
 
-    time_sec = time(NULL);
+    time_sec = gf_time();
     gf_time_fmt(timestamp, sizeof timestamp, time_sec, gf_timefmt_FT);
     timelen = strlen(timestamp);
 
